unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, PaxProgram, PaxCompiler, StdCtrls, PAXCOMP_STDLIB, PaxBasicLanguage;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    PaxCompiler1: TPaxCompiler;
    PaxProgram1: TPaxProgram;
    Memo2: TMemo;
    PaxBasicLanguage1: TPaxBasicLanguage;
    procedure Button1Click(Sender: TObject);
    procedure PaxProgram1Exception(Sender: TPaxProgram; E: Exception;
      const ModuleName: String; SourceLineNumber: Integer);
    procedure PaxProgram1PrintEvent(Sender: TPaxProgram; const Text: string);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
  IMPORT_SysUtils;

procedure TForm1.Button1Click(Sender: TObject);
begin
  PaxCompiler1.Reset;
  PaxCompiler1.RegisterLanguage(PaxBasicLanguage1);
  PaxCompiler1.AddModule('main', 'Basic');
  PaxCompiler1.AddCode('main', Memo1.Lines.Text);
  if PaxCompiler1.Compile(PaxProgram1) then
  begin
    PaxProgram1.Run;
  end
  else
    ShowMessage(PaxCompiler1.ErrorMessage[0]);
end;

procedure TForm1.PaxProgram1Exception(Sender: TPaxProgram; E: Exception;
  const ModuleName: String; SourceLineNumber: Integer);
begin
  Form1.Memo2.Text := Form1.Memo2.Text + #13#10 +
      'Exception (' + E.Message +
      ') raised at line ' + IntToStr(SourceLineNumber) + ':' +
      PaxCompiler1.Modules[ModuleName][SourceLineNumber] + #13#10;
end;

procedure TForm1.PaxProgram1PrintEvent(Sender: TPaxProgram; const Text: string);
begin
  Form1.Memo2.Text := Form1.Memo2.Text + Text;
end;

initialization

Register_SysUtils;

end.
